<?php

/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: admin_panel.php
| Author: Popupman
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";
include LOCALE.LOCALESET."admin/user_fields.php";

if (!checkrights("UF") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../../index.php"); }

if(file_exists(INFUSIONS."user_fields_manager/locale/".$settings['locale'].".php")) {
	include INFUSIONS."user_fields_manager/locale/".$settings['locale'].".php";
}else {
	include INFUSIONS."user_fields_manager/locale/English.php";
}

$new_field_step = "";

/***********************************************************************/
/********* CODE TO MOVE FIELDS UP AND DOWN IN THEIR ORDERS *************/
/***********************************************************************/

if ((isset($_GET['action']) && $_GET['action'] == "mu") && (isset($_GET['field_id']) && isnum($_GET['field_id']))) {
	$data2 = dbarray(dbquery("SELECT field_cat FROM ".DB_USER_FIELDS." WHERE field_id='".$_GET['field_id']." LIMIT 1'"));
	$data = dbarray(dbquery("SELECT field_id FROM ".DB_USER_FIELDS." WHERE field_cat='".$data2['field_cat']."' AND field_order='".intval($_GET['order'])."'"));
	$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_order=field_order+1 WHERE field_id='".$data['field_id']."'");
	$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_order=field_order-1 WHERE field_id='".$_GET['field_id']."'");
	redirect(FUSION_SELF.$aidlink);
} elseif ((isset($_GET['action']) && $_GET['action'] == "md") && (isset($_GET['field_id']) && isnum($_GET['field_id']))) {
	$data2 = dbarray(dbquery("SELECT field_cat FROM ".DB_USER_FIELDS." WHERE field_id='".$_GET['field_id']." LIMIT 1'"));
	$data = dbarray(dbquery("SELECT field_id FROM ".DB_USER_FIELDS." WHERE field_cat='".$data2['field_cat']."' AND field_order='".intval($_GET['order'])."'"));
	$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_order=field_order-1 WHERE field_id='".$data['field_id']."'");
	$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_order=field_order+1 WHERE field_id='".$_GET['field_id']."'");
	redirect(FUSION_SELF.$aidlink);
}

/***********************************************************************/
/******* CODE TO MOVE CATEGORIES UP AND DOWN IN THEIR ORDERS ***********/
/***********************************************************************/

elseif ((isset($_GET['action']) && ($_GET['action'] == "mcu" || $_GET['action'] == "mcd")) && (isset($_GET['field_cat_id']) && isnum($_GET['field_cat_id']))) {
	$data2 = dbarray(dbquery("SELECT field_cat_order FROM ".DB_USER_FIELD_CATS." WHERE field_cat_id = '".$_GET['field_cat_id']."'"));
	$data = dbarray(dbquery("SELECT field_cat_id FROM ".DB_USER_FIELD_CATS." WHERE field_cat_order = '".intval($_GET['order'])."'"));
	$result = dbquery("UPDATE ".DB_USER_FIELD_CATS." SET field_cat_order='".intval($_GET['order'])."' WHERE field_cat_id='".$_GET['field_cat_id']."'");
	$result = dbquery("UPDATE ".DB_USER_FIELD_CATS." SET field_cat_order='".$data2['field_cat_order']."' WHERE field_cat_id = '".$data['field_cat_id']."'");
	redirect(FUSION_SELF.$aidlink);
} 

/***********************************************************************/
/********************* CODE TO ADD NEW FIELDS **************************/
/***********************************************************************/

elseif(isset($_GET['action']) && $_GET['action'] == "addfield" && isset($_POST['input']) && isset($_POST['field_type']) && file_exists("field_types/".stripinput($_POST['field_type']).".php")) {
	if ($_POST['input'] == "Add") {
		$new_field_name = isset($_POST['new_field_name']) ? trim(stripinput($_POST['new_field_name'])) : "";
		if($new_field_name == "") redirect(FUSION_SELF.$aidlink."&amp;error=nf1");
		$dbname_parts = preg_split("/[^a-zA-Z0-9]/",$new_field_name,-1,PREG_SPLIT_NO_EMPTY);
		$new_field_dbname = "user_";
		foreach($dbname_parts as $part) $new_field_dbname.=$part;
		$no_duplicate = true;
		if ($temp = opendir(INCLUDES."user_fields/")) {
			while (false !== ($file = readdir($temp))) {
				if (!in_array($file, array("..",".","index.php")) && !is_dir(INCLUDES."user_fields/".$file)) {
					if (preg_match("/_var.php/i", $file)) {
						$field_name = explode("_",$file);
						$field_name = $field_name[0]."_".$field_name[1];
						if (file_exists(LOCALE.LOCALESET."user_fields/".$field_name.".php")) {
							include LOCALE.LOCALESET."user_fields/".$field_name.".php";
						}
						include INCLUDES."user_fields/".$file;
						if($new_field_name == $user_field_name || $user_field_dbname == $new_field_dbname)
							$no_duplicate = false;
					}
				}
			}
			closedir($temp);
		}
		if(!$no_duplicate) redirect(FUSION_SELF.$aidlink."&amp;error=nf2");
		$new_field_req   = $_POST['new_field_req'];
		$new_field_display = $_POST['new_field_display'];
		$new_field_group = isnum($_POST['new_field_group']) ? $_POST['new_field_group'] : 1;
		$new_field_desc  = stripinput($_POST['new_field_desc']);
		$new_field_step = "create";
		include "field_types/".stripinput($_POST['field_type']).".php";
		unset($new_field_step);
		$handle = fopen(INCLUDES."user_fields/".$new_field_dbname."_include.php", "w+");
		fwrite($handle,$new_field_include);
		fclose($handle);
		$handle = fopen(INCLUDES."user_fields/".$new_field_dbname."_include_var.php", "w+");
		fwrite($handle,$new_field_include_var);
		fclose($handle);
		$result = dbquery("SELECT field_cat, field_order FROM ".DB_USER_FIELDS." WHERE field_name='".stripinput($_GET['enable'])."'");
		$field_order = dbresult(dbquery("SELECT MAX(field_order) FROM ".DB_USER_FIELDS." WHERE field_cat='".$new_field_group."'"), 0) + 1;
		include INCLUDES."user_fields/".$new_field_dbname."_include_var.php";
		if (!$user_field_dbinfo || $result = dbquery("ALTER TABLE ".DB_USERS." ADD ".$user_field_dbname." ".$user_field_dbinfo)) {
			$result = dbquery("INSERT INTO ".DB_USER_FIELDS." (field_name, field_cat, field_order) VALUES ('".$user_field_dbname."', '".$new_field_group."', '".$field_order."')");
		}
		redirect(FUSION_SELF.$aidlink);
	}else {
		echo "<form method='post' action='".FUSION_SELF.$aidlink."&amp;action=addfield'>";
		echo "<input type='hidden' name='field_type' value='".stripinput($_POST['field_type'])."'>";
		echo "<table class='center'>";
		echo "<tr><td colspan='2' align='center' class='tbl2'><strong>Input Field Settings for New Field</strong></td></tr>";
		echo "<tr><td class='tbl1'>".$locale['M12'].":</td><td class='tbl1'><input type='text' name='new_field_name' class='textbox' maxlength='45' style='width:200px;'></td></tr>";
		echo "<tr><td class='tbl1'>".$locale['402'].":</td><td class='tbl1'><input type='text' name='new_field_desc' class='textbox' style='width:200px;'></td></tr>";
		$cats = dbquery("SELECT field_cat_id,field_cat_name FROM ".DB_USER_FIELD_CATS." ORDER BY field_cat_order");
		$options = "";
		while($cat = dbarray($cats)) $options.="<OPTION value='".$cat['field_cat_id']."'".(isset($_GET['field_cat_id']) && $_GET['field_cat_id'] == $cat['field_cat_id'] ? " SELECTED " : "").">".$cat['field_cat_name']."</OPTION>";
		echo "<tr><td class='tbl1'>".$locale['M15'].":</td><td class='tbl1'><SELECT name='new_field_group' class='textbox' style='width:200px;'>".$options."</SElECT></td></tr>";
		$new_field_step = "input";
		include "field_types/".$_POST['field_type'].".php";
		unset($new_field_step);
		echo "<tr><td class='tbl1'>".$locale['M13'].":</td><td class='tbl1'><input type='checkbox' name='new_field_display' CHECKED></td></tr>";
		echo "<tr><td class='tbl1'>".$locale['M14'].":</td><td class='tbl1'><input type='checkbox' name='new_field_req'></td></tr>";
		echo "<tr><td class='tbl1' colspan='2' align='center'><input type='submit' name='input' value='".$locale['B1']."' class='button'> <input type='button' onClick='history.back();' value='".$locale['B3']."' class='button'></td></tr>";
		echo "</table>";
		echo "</form>";
	}
} 

/***********************************************************************/
/********** CODE TO ENABLE OR EDIT NON-UFM CREATED FIELDS **************/
/***********************************************************************/

elseif (isset($_GET['enable']) && file_exists(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include_var.php") && file_exists(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include.php")) {
	if (file_exists(LOCALE.LOCALESET."user_fields/".stripinput($_GET['enable']).".php")) {
		include LOCALE.LOCALESET."user_fields/".stripinput($_GET['enable']).".php";
	}
	include INCLUDES."user_fields/".stripinput($_GET['enable'])."_include_var.php";
		
	if (isset($_POST['enable'])) {
		
		$new_field_name = trim(stripinput($_POST['user_field_name']));
		if($new_field_name == "") redirect(FUSION_SELF.$aidlink."&amp;error=nf1");
		
		$field_cat = isnum($_POST['field_cat']) ? $_POST['field_cat'] : 0;
		$result = dbquery("SELECT field_cat, field_order FROM ".DB_USER_FIELDS." WHERE field_name='".stripinput($_GET['enable'])."'");
		if (dbrows($result)) {
			$data = dbarray($result);
			if($field_cat != $data['field_cat']) {
			$field_order = dbresult(dbquery("SELECT MAX(field_order) FROM ".DB_USER_FIELDS." WHERE field_cat='".$field_cat."'"), 0) + 1;
				$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_cat='".$field_cat."', field_order='".$field_order."' WHERE field_name='".stripinput($_GET['enable'])."'");
				$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_order=field_order-1 WHERE field_cat='".$data['field_cat']."' AND field_order>'".$data['field_order']."'");
			}
		} else {
			$field_order = dbresult(dbquery("SELECT MAX(field_order) FROM ".DB_USER_FIELDS." WHERE field_cat='".$field_cat."'"), 0) + 1;
			if (!$user_field_dbinfo || $result = dbquery("ALTER TABLE ".DB_USERS." ADD ".$user_field_dbname." ".$user_field_dbinfo)) {
				$result = dbquery("INSERT INTO ".DB_USER_FIELDS." (field_name, field_cat, field_order) VALUES ('".$user_field_dbname."', '".$field_cat."', '".$field_order."')");
			}
		}
		///Now we edit the files for display or required.
		$field_req = $_POST['user_field_req'];
		$field_display = $_POST['user_field_display'];
		$handle = fopen(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include_var.php", "r");
		$file_contents = fread($handle,filesize(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include_var.php"));
		fclose($handle);
		
		$handle2 = fopen(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include.php", "r");
		$file_contents2 = fread($handle2,filesize(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include.php"));
		fclose($handle2);
		
		$file_contents = preg_replace('/user_field_name(\s*)=(\s*)"(.*?)"/', 'user_field_name\\1=\\2"'.$new_field_name.'"', $file_contents);
		
		if(isset($user_field_display)) {
			$file_contents = preg_replace('/user_field_display(\s*)=(\s*)"(.*?)"/', 'user_field_display\\1=\\2"'.$field_display.'"', $file_contents);
		}else {
			$file_contents = str_replace('?>',"\n\$user_field_display=\"".$field_display."\";\n?>", $file_contents);
			$file_contents2 = preg_replace('/profile_method(\s*)==(\s*)"display"/', "profile_method\\1==\\2\"display\" && (\$user_field_display || iADMIN)", $file_contents2);
			$file_contents2 = str_replace("if (!defined(\"IN_FUSION\")) { die(\"Access Denied\"); }","if (!defined(\"IN_FUSION\")) { die(\"Access Denied\"); }\nif(isset(\$user_field_req)) unset(\$user_field_req);\nif(isset(\$user_field_display)) unset(\$user_field_display);\ninclude INCLUDES.\"user_fields/".stripinput($_GET['enable'])."_include_var.php\";", $file_contents2);
		}
		if(isset($user_field_req)) {
			$file_contents = preg_replace('/user_field_req(\s*)=(\s*)"(.*?)"/', 'user_field_req\\1=\\2"'.$field_req.'"', $file_contents);
		}else {
			$file_contents = str_replace('?>',"\n\$user_field_req=\"".$field_req."\";\n?>", $file_contents);			
			$file_contents2 = str_replace('} elseif ($profile_method == "validate_insert") {',"} elseif (\$profile_method == \"validate_insert\") {\n	if(\$user_field_req && trim(stripinput(\$_POST['".$user_field_dbname."'])) == \"\") \$error = \"".$user_field_name." ".$locale['M16']."\";",$file_contents2);
			$file_contents2 = str_replace('} elseif ($profile_method == "validate_update") {',"} elseif (\$profile_method == \"validate_update\") {\n	if(\$user_field_req && trim(stripinput(\$_POST['".$user_field_dbname."'])) == \"\") \$error = \"".$user_field_name." ".$locale['M16']."\";",$file_contents2);
		}
		$handle = fopen(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include_var.php","w+");
		fwrite($handle,$file_contents);
		fclose($handle);
		
		$handle2 = fopen(INCLUDES."user_fields/".stripinput($_GET['enable'])."_include.php", "w+");
		fwrite($handle2,$file_contents2);
		fclose($handle2);

		//redirect(FUSION_SELF.$aidlink);
	} else {
		$result = dbquery("SELECT field_cat FROM ".DB_USER_FIELDS." WHERE field_name='".stripinput($_GET['enable'])."'");
		if (dbrows($result)) {
			$data = dbarray($result);
			$field_cat = $data['field_cat'];
			$form_title = $locale['420'];
		} else {
			$field_cat = "";
			$form_title = $locale['421'];
		}
		opentable($form_title);
		echo "<form name='cat_form' method='post' action='".FUSION_SELF.$aidlink."&amp;enable=".stripinput($_GET['enable'])."'>\n";
		echo "<table cellpadding='0' cellspacing='0' class='center'>\n<tr>\n";
		echo "<td class='tbl1'>".$locale['422']."</td>\n";
		echo "<td class='tbl1'><input type='text' name='user_field_name' class='textbox' style='width:200px;' value='".$user_field_name."'></td>\n";
		echo "</tr>\n<tr>\n";
		echo "<td class='tbl1'>".$locale['M13']."</td>\n";
		echo "<td class='tbl1'><input type='checkbox' name='user_field_display' ".(!isset($user_field_display) || $user_field_display ? "CHECKED" : "")."></td>\n";
		echo "</tr>\n<tr>\n";
		echo "</tr>\n<tr>\n";
		echo "<td class='tbl1'>".$locale['M14']."</td>\n";
		echo "<td class='tbl1'><input type='checkbox' name='user_field_req' ".(isset($user_field_req) && $user_field_req ? "CHECKED" : "")."></td>\n";
		echo "</tr>\n<tr>\n";
		echo "<td class='tbl1'>".$locale['423']."</td>\n";
		echo "<td class='tbl1'><select name='field_cat' class='textbox'>\n";
		$result = dbquery("SELECT field_cat_id, field_cat_name FROM ".DB_USER_FIELD_CATS." ORDER BY field_cat_order");
		$sel = "";
		if (dbrows($result)) {
			while ($data = dbarray($result)) {
				if ($field_cat)  { $sel = ($field_cat == $data['field_cat_id'] ? " selected='selected'" : ""); }
				echo "<option value='".$data['field_cat_id']."'".$sel.">".$data['field_cat_name']."</option>\n";
			}
		}
		echo "</select>\n</td>\n";
		echo "</tr>\n<tr>\n";
		echo "<td align='center' colspan='2' class='tbl'>\n";
		echo "<input type='submit' name='enable' value='".($field_cat ? $locale['424'] : $locale['425'])."' class='button' /> <input type='button' onClick='location.href=\"".FUSION_SELF.$aidlink."\";' class='button' value='".$locale['B2']."'></td>\n";
		echo "</tr>\n</table>\n</form>\n";
		closetable();
	}
}

/***********************************************************************/
/*********************** CODE TO DISABLE FIELDS ************************/
/***********************************************************************/

elseif ((isset($_GET['disable']) && isnum($_GET['disable']))) {
	$data = dbarray(dbquery("SELECT field_name, field_cat, field_order FROM ".DB_USER_FIELDS." WHERE field_id='".$_GET['disable']."'"));
	if (file_exists(LOCALE.LOCALESET."user_fields/".$data['field_name'].".php")) {
		include LOCALE.LOCALESET."user_fields/".$data['field_name'].".php";
	}
	include INCLUDES."user_fields/".$data['field_name']."_include_var.php";
	if (!$user_field_dbinfo || $result = dbquery("ALTER TABLE ".DB_USERS." DROP ".$user_field_dbname)) {
		$result = dbquery("UPDATE ".DB_USER_FIELDS." SET field_order=field_order-1 WHERE field_cat='".$data['field_cat']."' AND field_order>'".$data['field_order']."'");
		$result = dbquery("DELETE FROM ".DB_USER_FIELDS." WHERE field_id='".$_GET['disable']."'");
	}
	redirect(FUSION_SELF.$aidlink);
} 

/***********************************************************************/
/***************** CODE TO COMPLETELY DELETE FIELDS ********************/
/***********************************************************************/

elseif(isset($_GET['delete_field']) && file_exists(INCLUDES."user_fields/".stripinput($_GET['delete_field'])."_include_var.php")) {
	if(isset($_POST['delete_field'])) {
		unlink(INCLUDES."user_fields/".stripinput($_GET['delete_field'])."_include_var.php");
		unlink(INCLUDES."user_fields/".stripinput($_GET['delete_field'])."_include.php");
		redirect(FUSION_SELF.$aidlink);
	} else {
		if (file_exists(LOCALE.LOCALESET."user_fields/".stripinput($_GET['delete_field']).".php")) {
			include LOCALE.LOCALESET."user_fields/".stripinput($_GET['delete_field']).".php";
		}
		include INCLUDES."user_fields/".stripinput($_GET['delete_field'])."_include_var.php";
		echo "<center><form action='".FUSION_SELF.$aidlink."&amp;delete_field=".stripinput($_GET['delete_field'])."' method='post'><font color='#F00'><strong>".$locale['M11']." <i>".$user_field_name."</i></strong><br /><input type='submit' value='".$locale['B5']."' name='delete_field' class='button'> <input type='button' class='button' value='".$locale['B2']."' onClick='history.back();'></center></font><br />";
	}
} 

/***********************************************************************/
/******* CODE TO DELETE CATEGORIES AND DISABLE THEIR FIELDS ************/
/***********************************************************************/

elseif (isset($_GET['action']) && $_GET['action'] == "delcat" && isset($_POST['confirm']) && isset($_GET['field_cat_id']) && isnum($_GET['field_cat_id'])) {
	$fields = dbquery("SELECT field_name, field_id FROM ".DB_USER_FIELDS." WHERE field_cat='".$_GET['field_cat_id']."'");
	while($data = dbarray($fields)) {
		if (file_exists(LOCALE.LOCALESET."user_fields/".$data['field_name'].".php")) {
			include LOCALE.LOCALESET."user_fields/".$data['field_name'].".php";
		}
		include INCLUDES."user_fields/".$data['field_name']."_include_var.php";
		if (!$user_field_dbinfo || $result = dbquery("ALTER TABLE ".DB_USERS." DROP ".$user_field_dbname)) {
			$result = dbquery("DELETE FROM ".DB_USER_FIELDS." WHERE field_id='".$data['field_id']."'");
		}
	}
	$result = dbquery("DELETE FROM ".DB_USER_FIELD_CATS." WHERE field_cat_id='".$_GET['field_cat_id']."'");
	redirect(FUSION_SELF.$aidlink);
} 

/***********************************************************************/
/****************** CODE TO ADD NEW CATEGORIES *************************/
/***********************************************************************/

elseif(isset($_GET['action']) && $_GET['action'] == "addcat" && isset($_POST['field_cat_name'])) {
	$field_cat_name = trim(stripinput($_POST['field_cat_name']));
	if($field_cat_name == "") redirect(FUSION_SELF.$aidlink."&amp;action=addcat&amp;error=1");
	if(dbrows(dbquery("SELECT field_cat_id FROM ".DB_USER_FIELD_CATS." WHERE field_cat_name='".$_POST['field_cat_name']."'"))) redirect(FUSION_SELF.$aidlink."&amp;action=addcat&amp;error=2");
	$data = dbarray(dbquery("SELECT MAX(field_cat_order) as max FROM ".DB_USER_FIELD_CATS));
	dbquery("INSERT INTO ".DB_USER_FIELD_CATS." (field_cat_id,field_cat_name,field_cat_order) VALUES(NULL,'".$field_cat_name."','".($data['max']+1)."')");
	redirect(FUSION_SELF.$aidlink);
}


/***********************************************************************/
/******* THE FOLLOWING CODE HANDLES FIRST FINIDING ALL AVAILABLE *******/
/*********** FIELDS AND THEN DISPLAY THOSE THAT ARE ENABLED ************/
/***********************************************************************/


$available_fields = array(); $enabled_fields = array();

if ($temp = opendir(INCLUDES."user_fields/")) {
	while (false !== ($file = readdir($temp))) {
		if (!in_array($file, array("..",".","index.php")) && !is_dir(INCLUDES."user_fields/".$file)) {
			if (preg_match("/_var.php/i", $file)) {
				$field_name = explode("_", $file);
				$available_fields[] = $field_name[0]."_".$field_name[1];
				unset($field_name);
			}
		}
	}
	closedir($temp);
}
sort($available_fields);

/**********************************************************************/
/************** CODE FOR THE FIRST STEP OF CERTAIN FORMS **************/
/**********************************************************************/
if(isset($_GET['action']) && $_GET['action'] == "delcat" && isnum($_GET['field_cat_id'])) {
	$data = dbquery("SELECT field_cat_name FROM ".DB_USER_FIELD_CATS." WHERE field_cat_id = '".$_GET['field_cat_id']."'");
	if(dbrows($data)) {
		$data = dbarray($data);
		echo "<form name='delcat_form' method='post' action='".FUSION_SELF.$aidlink."&amp;action=delcat&amp;field_cat_id=".$_GET['field_cat_id']."'><table align='center' style='color:#F00;'><tr><td>".$locale['M4']."<br/>".$locale['M5']." <strong>".$data['field_cat_name']."</strong></td></tr><td align='center'><input type='submit' name='confirm' value='".$locale['B5']."' class='button' /> <input type='button' onClick='location.href=\"".FUSION_SELF.$aidlink."\";' class='button' value='".$locale['B2']."'></td></tr></table></form>";
	}
}elseif (isset($_GET['action']) && $_GET['action'] == "addcat") {
	echo "<form name='addcat_form' method='post' action='".FUSION_SELF.$aidlink."&amp;action=addcat'><table align='center'>";
	if(isset($_GET['error']) && isnum($_GET['error'])) {
		if ($_GET['error'] == 1) $emessage = $locale['M2'];
		elseif ($_GET['error'] == 2) $emessage = $locale['M3'];
		echo "<tr><td colspan='2' align='center' style='color:#F00;'>".$emessage."</td></tr>";
	}
	echo "<tr><td>".$locale['M10'].":</td><td><input type='text' name='field_cat_name' class='textbox' style='width:200px;' maxlength='200' /></td></tr><tr><td align='center' colspan='2'><input type='submit' value='".$locale['B1']."' class='button' /> <input type='button' onClick='location.href=\"".FUSION_SELF.$aidlink."\";' class='button' value='".$locale['B2']."'></td></tr></table></form>";
}elseif (isset($_GET['action']) && $_GET['action'] == "addfield" && !isset($_POST['input'])) {
	///first.. find all the field types that are allowed
	$available_field_types = array();
	if ($temp = opendir("field_types/")) {
		while (false !== ($file = readdir($temp))) {
			if (!in_array($file, array("..",".","index.php")) && !is_dir("field_types/".$file)) {
				if (preg_match("/_files.php/i", $file)) {
					$field_name = explode("_", $file);
					$available_field_types[] = $field_name[0];
					unset($field_name);
				}
			}
		}
		closedir($temp);
	}
	$options = "";
	foreach($available_field_types as $field_type) {
		include "field_types/".$field_type.".php";
		$options.="<OPTION value='".$field_type."'>".$field_type_title."</OPTION>";
	}
	echo "<form name='addfield_form' method='post' action='".FUSION_SELF.$aidlink."&amp;action=addfield".(isset($_GET['field_cat_id']) && isnum($_GET['field_cat_id']) ? "&amp;field_cat_id=".$_GET['field_cat_id'] : "")."'><table align='center'><tr><td>".$locale['M6']." <SELECT name='field_type' class='textbox'>".$options."</SELECT> ".$locale['M7']."</td></tr><tr><td align='center'><input type='submit' value='".$locale['B4']."' class='button' name='input'> <input type='button' onClick='location.href=\"".FUSION_SELF.$aidlink."\";' class='button' value='".$locale['B2']."'></td></tr></table></form>";
}

if(isset($_GET['error'])) {
	if($_GET['error'] == "nf1") $message = $locale['M8'];
	elseif($_GET['error'] == "nf2") $message = $locale['M9'];
	else $message = trim(stripinput($_GET['error']));
	echo "<center><font color='#F00'><strong>".$message." <br /><input type='button' onClick='history.back();' value='".$locale['B3']."' class='button'></strong></center><br />";
}
/***********************************************************************/
/*************** CODE TO A LIST OF DISABLED FIELDS *********************/
/***********************************************************************/

opentable($locale['400']);
echo "<center><a href='".FUSION_SELF.$aidlink."&amp;action=addcat'>[".$locale['L1']."]</a></center><br />";
$result = dbquery(
	"SELECT field_id, field_name, field_cat, field_order, field_cat_name, field_cat_order, field_cat_id FROM ".DB_USER_FIELDS." tuf
	RIGHT JOIN ".DB_USER_FIELD_CATS." tufc ON tuf.field_cat = tufc.field_cat_id
	ORDER BY field_cat_order, field_order"
);
$num_cats = dbrows(dbquery(
	"SELECT field_cat_order FROM ".DB_USER_FIELD_CATS." WHERE field_cat_id IN (SElECT field_cat FROM ".DB_USER_FIELDS.")"
));
$max_order = dbarray(dbquery(
	"SELECT MAX(field_cat_order) as max FROM ".DB_USER_FIELD_CATS
));
$max_order = $max_order['max'];
if (dbrows($result)) {
	$cat = 1; $i = 1; $k = 0;
	while($data = dbarray($result)) {
		if(isset($user_field_req)) unset($user_field_req);
		if ($cat != $data['field_cat_name']) {
			if($k != 0) echo "</table><br />";
			echo "<table cellpadding='0' cellspacing='1' width='80%' class='tbl-border center'>\n<tr>\n";
			$rows = dbcount("(field_id)", DB_USER_FIELDS, "field_cat='".$data['field_cat']."'");
			$cat = $data['field_cat_name'];
			$i = 1;
			echo "<td colspan='4' class='tbl2' align='center'><strong>".$data['field_cat_name']."</strong><a href='".FUSION_SELF.$aidlink."&amp;action=addfield&amp;field_cat_id=".$data['field_cat_id']."'><br />".$locale['L3']."</a> - <a href='".FUSION_SELF.$aidlink."&amp;action=delcat&amp;field_cat_id=".$data['field_cat_id']."'>".$locale['L2']."</a><br />";
			$cup   = dbarray(dbquery("SELECT field_cat_order FROM ".DB_USER_FIELD_CATS." WHERE field_cat_order < ".$data['field_cat_order']." ORDER BY field_cat_order DESC LIMIT 1"));
			$cup   = $cup['field_cat_order'];
			$cdown = dbarray(dbquery("SELECT field_cat_order FROM ".DB_USER_FIELD_CATS." WHERE field_cat_order > ".$data['field_cat_order']." ORDER BY field_cat_order ASC LIMIT 1"));
			$cdown = $cdown['field_cat_order'];
			if($k == 0 && $max_order != $data['field_cat_order']) {
				echo " <a href='".FUSION_SELF.$aidlink."&amp;action=mcd&amp;order=$cdown&amp;field_cat_id=".$data['field_cat_id']."'><img src='".THEME."images/down.gif' alt='".$locale['405']."' title='".$locale['405']."' style='border:0px;' /></a>\n";
			}elseif($data['field_cat_order'] < $max_order) {
				echo " <a href='".FUSION_SELF.$aidlink."&amp;action=mcu&amp;order=$cup&amp;field_cat_id=".$data['field_cat_id']."'><img src='".THEME."images/up.gif' alt='".$locale['406']."' title='".$locale['406']."' style='border:0px;' /></a>\n";
				echo " <a href='".FUSION_SELF.$aidlink."&amp;action=mcd&amp;order=$cdown&amp;field_cat_id=".$data['field_cat_id']."'><img src='".THEME."images/down.gif' alt='".$locale['405']."' title='".$locale['405']."' style='border:0px;' /></a>\n";
			}elseif($data['field_cat_order'] == $max_order && ($k!= 0 || dbrows($result) > 1)) {
				echo " <a href='".FUSION_SELF.$aidlink."&amp;action=mcu&amp;order=$cup&amp;field_cat_id=".$data['field_cat_id']."'><img src='".THEME."images/up.gif' alt='".$locale['406']."' title='".$locale['406']."' style='border:0px;' /></a>\n";
			}
			echo "</td></tr>";
			echo "<tr><td width='1%' class='tbl2' style='white-space:nowrap'><strong>".$locale['401']."</strong></td>\n";
			echo "<td class='tbl2' style='white-space:nowrap'><strong>".$locale['402']."</strong></td>\n";
			echo "<td width='1%' class='tbl2' style='white-space:nowrap'><strong>".$locale['403']."</strong></td>\n";
			echo "<td width='1%' class='tbl2' style='white-space:nowrap'><strong>".$locale['404']."</strong></td>\n";
			echo "</tr>\n";
			if($rows < 1) {
				echo "<tr><td class='tbl1' style='white-space:nowrap' colspan='4' align='center'><strong>".$locale['M1']."</strong></td></tr>".($k==0 ? "</table><br />" : "");
			}
		}
		if($rows >= 1) {
			if (file_exists(LOCALE.LOCALESET."user_fields/".$data['field_name'].".php")) {
				include LOCALE.LOCALESET."user_fields/".$data['field_name'].".php";
			}
			include INCLUDES."user_fields/".$data['field_name']."_include_var.php";
			$enabled_fields[] = $data['field_name'];
			echo "<tr>\n";
			echo "<td width='1%' class='tbl1' style='white-space:nowrap'>".(isset($user_field_req) && $user_field_req ? "<font color='#F00'>*" : "<font>").$user_field_name."</font></td>\n";
			echo "<td class='tbl1' style='white-space:nowrap'>".$user_field_desc."</td>\n";
			echo "<td width='1%' class='tbl1' style='white-space:nowrap'>".$data['field_order'];
			if ($rows != 1) {
				$up = $data['field_order'] - 1;
				$down = $data['field_order'] + 1;
				if ($i == 1) {
					echo " <a href='".FUSION_SELF.$aidlink."&amp;action=md&amp;order=$down&amp;field_id=".$data['field_id']."'><img src='".THEME."images/down.gif' alt='".$locale['405']."' title='".$locale['405']."' style='border:0px;' /></a>\n";
				} elseif ($i < $rows) {
					echo " <a href='".FUSION_SELF.$aidlink."&amp;action=mu&amp;order=$up&amp;field_id=".$data['field_id']."'><img src='".THEME."images/up.gif' alt='".$locale['406']."' title='".$locale['406']."' style='border:0px;' /></a>\n";
					echo " <a href='".FUSION_SELF.$aidlink."&amp;action=md&amp;order=$down&amp;field_id=".$data['field_id']."'><img src='".THEME."images/down.gif' alt='".$locale['405']."' title='".$locale['405']."' style='border:0px;' /></a>\n";
				} else {
					echo " <a href='".FUSION_SELF.$aidlink."&amp;action=mu&amp;order=$up&amp;field_id=".$data['field_id']."'><img src='".THEME."images/up.gif' alt='".$locale['406']."' title='".$locale['406']."' style='border:0px;' /></a>\n";
				}
			}
			$i++; $k++;
			echo "</td>\n<td width='1%' class='tbl1' style='white-space:nowrap'>\n";
			echo "<a href='".FUSION_SELF.$aidlink."&amp;enable=".$data['field_name']."'>".$locale['407']."</a> -\n";
			echo "<a href='".FUSION_SELF.$aidlink."&amp;disable=".$data['field_id']."'>".$locale['408']."</a>\n";
			echo "</td>\n</tr>\n";
		}
	}
	if($k != 0) echo "</table>\n";
}
closetable();

opentable($locale['430']);
echo "<table cellpadding='0' cellspacing='1' width='80%' class='tbl-border center'>\n<tr>\n";
if (count($available_fields) != count($enabled_fields)) {
	echo "<td width='1%' class='tbl2' style='white-space:nowrap'><strong>".$locale['401']."</strong></td>\n";
	echo "<td class='tbl2' style='white-space:nowrap'><strong>".$locale['402']."</strong></td>\n";
	echo "<td width='1%' class='tbl2' style='white-space:nowrap'><strong>".$locale['404']."</strong></td>\n";
	echo "</tr>\n";
	$i = 0;
	for ($k = 0; $k < count($available_fields); $k++) {
		if (!in_array($available_fields[$k], $enabled_fields)) {
			if (file_exists(LOCALE.LOCALESET."user_fields/".$available_fields[$k].".php")) {
				include LOCALE.LOCALESET."user_fields/".$available_fields[$k].".php";
			}
			include INCLUDES."user_fields/".$available_fields[$k]."_include_var.php";
			echo "<tr>\n";
			echo "<td width='1%' class='tbl1' style='white-space:nowrap'>".$user_field_name."</td>\n";
			echo "<td class='tbl1' style='white-space:nowrap'>".$user_field_desc."</td>\n";
			echo "<td width='1%' class='tbl1' style='white-space:nowrap'><a href='".FUSION_SELF.$aidlink."&amp;enable=".$available_fields[$k]."'>".$locale['431']."</a> - <a href='".FUSION_SELF.$aidlink."&amp;delete_field=".$available_fields[$k]."'>".$locale['L2']."</a></td>\n";
			echo "</tr>\n";
			$i++;
		}
	}
} else {
	echo "<td align='center' class='tbl1'>".$locale['440']."</td>\n</tr>\n";
}
echo "</table>\n";
closetable();

require_once THEMES."templates/footer.php";
?>